import java.awt.event.*;
import java.util.*;

import sv.kernel.CommandSet;

/** 
 * CommandSet3D.java
 * Event handler for GFrame3D
 * @version 1.0   10/1/97 
 * @author Byeongseob Ki
 */

public class CommandSet3D extends CommandSet
                   implements ActionListener, ItemListener {
  GFrame3D this_frame;

  public static final int WIRE         = 1;
  public static final int FILL         = 2;
  public static final int SHADING      = 3;
  public static final int THRESHOLD    = 4;
  public static final int DISCONNECT   = 5;

  int id;

  public CommandSet3D(GFrame3D this_frame, int id) {
     this.this_frame = this_frame;
     this.id = id;
  }

  /**
   * overrided function for action event
   * when event occurs, 
   *     1. check first global flag mode
   *     2. collaboration
   */
  public void actionPerformed(ActionEvent e) {

     switch(id) {
       case SAVEAS:
       case PRINT:
       case GIFSEQUENCE:
       case CUT:
       case COPY:
       case PASTE:
       case GOTO:
       case THRESHOLD:
       case DISCONNECT:
       case BUFFERSIZE:
         this_frame.doWork(id, null);
         break;

       case QUIT: 
       case ANIMATE:
       case NEXT:
       case PREVIOUS:
       case SPLIT: 
         this_frame.svServer.fmanager.action3d(this_frame, id, null, true);
         break;
 
       case STOP:
         String[] arg = new String[1];
         arg[0] = String.valueOf(this_frame.currentTime);
         this_frame.svServer.fmanager.action3d(this_frame, id, arg, true);
         break;
     }
  }

  /**
   * overrided function for item state
   */
  public void itemStateChanged(ItemEvent e) {
     String[] args = new String[1];

     switch(id) {
       case GMINMAX:
          args[0] = String.valueOf(this_frame.checkMI.getState());
          break;

       case WIRE:
          args[0] = String.valueOf(this_frame.wireMI.getState());
          break;

      case FILL:
          args[0] = String.valueOf(this_frame.fillMI.getState());
          break;

      case SHADING:
          args[0] = String.valueOf(this_frame.shadingMI.getState());
          break;

      case STEALTH:
         this_frame.doWork(id, null);
         break;
     }
     this_frame.svServer.fmanager.action3d(this_frame, id, args, true);
  }

} // end of class


