
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

/** 
 * ConInterface.java
 * Manage and configure the connection between servers
 * @version 1.0   10/1/97
 * @author Byeongseob Ki
 */

class ConInterface extends Dialog implements ActionListener {

  // server TextField
  private TextField serverField;
  
  // port TextField
  private TextField portField;

  // to access svserver class
  protected svserver this_server;

  public ConInterface(Frame server, String title) {
     super(server, title, true);
     this_server = (svserver)server;
     
     // make GUI components
     makeGUI();
     pack();
  }


  /**
   * overrided method (for buttons)
   */
  public void actionPerformed(ActionEvent e) {
     String command = e.getActionCommand();

     if (command.equals("Connect")) {                 
        String dummy = serverField.getText().trim();
        if (dummy.length() < 1) this.dispose();
        String server = dummy;

        dummy = portField.getText().trim();
        if (dummy.length() < 4) dummy = "7654";
        int port = Integer.valueOf(dummy).intValue();

        this_server.cmanager.peerConnectRequest(server, port);
        this.dispose();

     } else if (command.equals("Disconnect")) {       
        String dummy = serverField.getText().trim();
        if (dummy.length() < 1) this.dispose();
        String server = dummy;

        dummy = portField.getText().trim();
        if (dummy.length() < 4) dummy = "7654";
        int port = Integer.valueOf(dummy).intValue();

        this_server.cmanager.peerDisconnectRequest();
        this.dispose();

     } else if (command.equals("Cancel")) {       
        this.dispose();
     }
  }


  // make GUI of this class
  private void makeGUI() {
     Component c;
     setLayout(new BorderLayout());

     GridBagLayout gbl = new GridBagLayout();
     GridBagConstraints gbc = new GridBagConstraints();
     
     // define upper, center and lower panel
     JPanel centerPanel = new JPanel();
     Panel lowerPanel = new Panel();

     // make center part(current setting panel)
     centerPanel = new JPanel();
     centerPanel.setBorder(new TitledBorder("Connect to ..."));
     centerPanel.setLayout(gbl);

     gbc.gridx = 1;
     gbc.gridy = 1;
     c = new Label("Hostname:");
     gbl.setConstraints(c, gbc);
     centerPanel.add(c);

     gbc.gridx = 1;
     gbc.gridy = 2;
     c = new Label("Port:");
     gbl.setConstraints(c, gbc);
     centerPanel.add(c);

     gbc.gridx = 2;
     gbc.gridy = 1;
     gbc.gridwidth = 4;
     serverField = new TextField(25);
     gbl.setConstraints(serverField, gbc);
     centerPanel.add(serverField);

     gbc.gridx = 2;
     gbc.gridy = 2;
     gbc.gridwidth = 4;
     portField = new TextField(25);
     gbl.setConstraints(portField, gbc);
     centerPanel.add(portField);
     portField.setText("7654");

     // make lower part(two buttons)
     lowerPanel.setLayout(new BorderLayout());
     lowerPanel.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));
     Button applybtn = new Button("Connect");
     applybtn.addActionListener(this);
     lowerPanel.add(applybtn);

     Button disconbtn = new Button("Disconnect");
     disconbtn.addActionListener(this);
     lowerPanel.add(disconbtn);

     Button quitbtn = new Button("Cancel");
     quitbtn.addActionListener(this);
     lowerPanel.add(quitbtn);

     // add all parts
     add("Center", centerPanel);
     add("South", lowerPanel);
  }

 
}


