
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

import sv.ui.*;

/** 
 * ConnectionHandler.java
 * Connection manager
 * @version 1.0  10/1/97
 * @author Byeongseob Ki
 */

class ConnectionHandler extends Frame implements ActionListener {
   svserver parent;

   TextArea    evtInfo=null;
   List        servers=null;
   TextField   chatwords;

   public ConnectionHandler(svserver parent) {
       super("Collaboration Monitor");
       this.parent = parent;

       setLayout(new BorderLayout());

       JPanel upperPanel = new JPanel();
       upperPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
       upperPanel.setBorder(SVUIC.systemBorder);
       upperPanel.add(new Label("Your words:"));
       upperPanel.add(chatwords = new TextField(40));
       chatwords.addActionListener(this);

       Panel centerPanel = new Panel();
       GridBagLayout      gbl = new GridBagLayout();
       GridBagConstraints gbc = new GridBagConstraints();
       centerPanel.setLayout(gbl);

       Label l       = new Label("Collaborators: ");
       l.setFont(new Font("Helvetica", Font.ITALIC, 12));
       gbc.weighty   = 0.0;
       gbc.weightx   = 0.4;
       gbc.gridwidth = 2;
       gbc.fill      = GridBagConstraints.HORIZONTAL;
       gbl.setConstraints(l, gbc);
       centerPanel.add(l);

       l = new Label("Event Information: ");
       l.setFont(new Font("Helvetica", Font.ITALIC, 12));
       gbc.weightx   = 0.6;
       gbc.gridwidth = GridBagConstraints.REMAINDER;
       gbl.setConstraints(l, gbc);
       centerPanel.add(l);

       gbc.weighty   = 0.5;
       gbc.weightx   = 0.4;
       gbc.gridwidth = 2;
       gbc.fill      = GridBagConstraints.BOTH;
       servers     = new List(12, false);
       servers.setForeground(Color.blue);
       gbl.setConstraints(servers, gbc);
       centerPanel.add(servers);
//       servers.addActionListener(this);

       evtInfo    = new TextArea(5, 40);
       gbc.weightx   = 0.6;
       gbc.fill      = GridBagConstraints.BOTH;
       gbc.gridwidth = GridBagConstraints.REMAINDER;
       evtInfo.setEditable(false);
       gbl.setConstraints(evtInfo, gbc);
       centerPanel.add(evtInfo);

       add("North", upperPanel);
       add("Center", centerPanel);
  }

   public void actionPerformed(ActionEvent e) {
      if (e.getSource() instanceof TextField) {
         String str = chatwords.getText();
         parent.cmanager.broadcastString(str);
         chatwords.setText("");
         addEventInfo("<me> " + str);
      } 
   }  


   /**
    * update collaborator item to List
    */
   public void updateListItem() {
      String name = " ";

      if (servers.getItemCount() > 0)
        servers.removeAll();

      Vector namevec = parent.cmanager.getNameVec();
      for (Enumeration e=namevec.elements(); e.hasMoreElements();) {
         String str = (String)e.nextElement();
         int index = str.indexOf(".");
         if (index > 0)
            name = str.substring(0, index);
         else
            name = str;
         servers.addItem(name);
      }
   }


   /**
    * add event information to TextArea
    * @param str event info to be added
    */
   public void addEventInfo(String str) {
      evtInfo.append(str + "\n");
   }

}
