import java.awt.*;
import java.io.*;

import sv.util.GIFEncoder;

/** 
 * GIFer.java
 * Thread class to make gif sequence
 * @version 1.0    8/1/97
 * @author Byeongseob Ki
 */

class GIFer extends Thread {

  GFPlane gf1D = null; 
  GFrame2D gf2D = null; 
  GFrame3D gf3D = null; 

  String name = null;
  int mode = 1;

  public GIFer(GFPlane gf, String name) {
     this.gf1D = gf;
     this.name = name;
     mode = 1;
  }

  public GIFer(GFrame2D gf, String name) {
     this.gf2D = gf;
     this.name = name;
     mode = 2;
  }

  public GIFer(GFrame3D gf, String name) {
     this.gf3D = gf;
     this.name = name;
     mode = 3;
  }


  public void run() {
    String target;

    if (mode == 1) {
        int savedpos = gf1D.currentTime;
        gf1D.currentTime = 0;
        gf1D.canvas.repaint();

        target = name + "1.gif";
        sleeping(target, 100);

        synchronized(this) {
           for (int i=0; i<gf1D.noOfTime; i++) {
             target = name + (i+1) + ".gif";
             Image img = gf1D.canvas.getImage();

             if (img != null) {
                try {
                   GIFEncoder encode = new GIFEncoder(img);
                   OutputStream output = 
                     new BufferedOutputStream(new FileOutputStream(target));
                   encode.Write(output);
                } catch (Exception e) {
                   e.printStackTrace();
                }
             }
             gf1D.next(true);
             sleeping(target, 100);
	   }
 
           gf1D.currentTime = savedpos;
           gf1D.canvas.repaint();
           gf1D.monitor.display("GIF Sequence making was done ...", false);
	}
    } else if (mode == 2) {
        int savedpos = gf2D.currentTime;
        gf2D.currentTime = 0;
        gf2D.canvas.destroyImage();
        gf2D.canvas.repaint();

        target = name + "1.gif";
        sleeping(target, 250);

        synchronized(this) {
           for (int i=0; i<gf2D.noOfTime; i++) {
             target = name + (i+1) + ".gif";
             Image img = gf2D.canvas.getImage();

             if (img != null) {
                try {
                   GIFEncoder encode = new GIFEncoder(img);
                   OutputStream output = 
                     new BufferedOutputStream(new FileOutputStream(target));
                   encode.Write(output);
                } catch (Exception e) {
                   e.printStackTrace();
                }
             }

             gf2D.next(true);
             sleeping(target, 250);
	   }
 
           gf2D.currentTime = savedpos;
           gf2D.canvas.repaint();
           gf2D.canvas.destroyImage();
           gf2D.monitor.display("GIF Sequence making was done ...", false);
	}
    } else if (mode == 3) {
        int savedpos = gf3D.currentTime;
        gf3D.currentTime = 0;
        gf3D.canvas.repaint();

        target = name + "1.gif";
        sleeping(target, 200);

        synchronized(this) {
           for (int i=0; i<gf3D.noOfTime; i++) {
             target = name + (i+1) + ".gif";
             Image img = gf3D.canvas.getImage();

             if (img != null) {
                try {
                   GIFEncoder encode = new GIFEncoder(img);
                   OutputStream output = 
                     new BufferedOutputStream(new FileOutputStream(target));
                   encode.Write(output);
                } catch (Exception e) {
                   e.printStackTrace();
                }
             }

             gf3D.next(true);
             sleeping(target, 200);
	   }
 
           gf3D.currentTime = savedpos;
           gf3D.canvas.repaint();
           gf3D.monitor.display("GIF Sequence making was done ...", false);
	}
    }
  } 

  private void sleeping(String target, int speed) {
    try {
      for (int i=0; i<10; i++) {
         if (mode == 1)
            gf1D.monitor.display(target + ": " + (i*10) + "% done", false);
         else if (mode == 2) 
            gf2D.monitor.display(target + ": " + (i*10) + "% done", false);
         else if (mode == 3) 
            gf3D.monitor.display(target + ": " + (i*10) + "% done", false);
         Thread.sleep(speed);
      }
    } catch (InterruptedException e) {
      System.out.println("GIF creation error...");
    }
  }
} // end of class


