
import java.awt.*;
import java.awt.event.*;
import java.net.*;

import browser.*;	       

public class HelpFrame extends Frame implements ActionListener {

   BrowserInterface browser;	// The browser object
   svserver svServer;

   public HelpFrame(svserver parent) {

      setTitle("SciVis Help");
     
      svServer = parent; 

      // Create a menu panel
      Panel p = new Panel();
      p.setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));

      Button b = new Button("Back");
      b.addActionListener(this);
      p.add(b);
		
      b = new Button("Forward");
      b.addActionListener(this);
      p.add(b);

      b = new Button("Quit");
      b.addActionListener(this);
      p.add(b);

      add("North",p);
		
      // Put browser into this frame
      browser = new BrowserInterface(this);
   }

  /**
   * set initial URL
   */
  public synchronized void setInitialURL(String url) {
    browser.URL_Process(url, null);
  }

  /**
   * set initial URL
   */
  public synchronized void setInitialURL(URL url) {
    browser.URL_Process(url);
  }

  /**
   * action for menu system
   */
  public void actionPerformed(ActionEvent evt) {
     String command = evt.getActionCommand();

     if (command.equals("Quit")) {
        svServer.mainb.helpBtn.setEnabled(true);
        this.dispose();

     } else if (command.equals("Back")) {
        // Go back in history list
       	browser.goBack();

     } else if (command.equals("Forward")) {
        // Go forward in history list
	browser.goForward();
     }
  }


} // end of class



