import java.awt.*;
import java.awt.event.*;

import sv.kernel.DataSet3D;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

import sv.ui.SVUIC;

class IsoValueSelector extends Frame implements ActionListener {
  TextField inputField;
  GFrame3D gf3d;
  float threshold, zmin, zmax;

  Checkbox modeBox;

  public IsoValueSelector(GFrame3D gf3d, 
                     float threshold, float zmin, float zmax) {
    setTitle("Iso Value");
    this.gf3d = gf3d;
    this.threshold = threshold;
    this.zmin = zmin;
    this.zmax = zmax;

    makeGUI();
    pack();
  }

  /**
   * overrided method
   */
  public void actionPerformed(ActionEvent evt) {
     String command = evt.getActionCommand();

     if ((evt.getSource() instanceof TextField) || 
                               command.equals("  Ok  ")) {   

        String input = inputField.getText().trim();
        if (input.length() < 1) 
           return;
        
        try {
           gf3d.setNewThreshold(Float.valueOf(input).floatValue(), modeBox.getState(), (DataSet3D)gf3d.dataSetVector.firstElement());
        } catch (Exception e) {
          gf3d.monitor.display("Is it a number? ...", true);
        }

     } else if (command.equals("Quit")) { 
        this.dispose();
        gf3d.selector = null;
     } 
  }

  // make GUI of this class
  private void makeGUI() {
     setLayout(new BorderLayout());

     JPanel p = new JPanel();
     p.setLayout(new BorderLayout());
     p.setBorder(new TitledBorder("Enter threshold"));


     p.add("North", new JLabel("Range: " + zmin + " - " + zmax));
     p.add("Center", inputField = new TextField(30));
     p.add("South",  modeBox = 
         new Checkbox("Change only current TimeData's threshold", false));
     inputField.setText(String.valueOf(threshold));
     inputField.addActionListener(this);

     Panel dummy = new Panel();      // for buttons
     dummy.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));
    
     Button okbtn = new Button("  Ok  ");
     okbtn.addActionListener(this);
     dummy.add(okbtn);

     Button quitbtn = new Button("Quit");
     quitbtn.addActionListener(this);
     dummy.add(quitbtn);

     add("Center", p);
     add("South", dummy);
  }
}
