import java.awt.*;
import java.awt.event.*;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;

import sv.ui.*;

/** 
 * MainButtons.java
 * Scivis main window interface
 * @version 1.0     10/15/97
 * @author Byeongseob Ki
 */

public class MainButtons extends JPanel {

  svserver svServer;
  
  LatchButton connectBtn, helpBtn, drawBtn, editBtn, checkBtn;

  MainButtons(svserver svServer) {
    this.svServer = svServer;

    makeGUI();
  }

  private void makeGUI() {
     setBorder(SVUIC.systemBorder);
     setLayout(new GridLayout(3, 4));
     Image img;
     LatchButton btn;

     SVUIC.iconImg = 
  svServer.loadImageIcon(getClass().getResource("icons/graph.gif"), "system icon").getImage();


     img = svServer.loadImageIcon(getClass().getResource("icons/connect.gif"), "connect").getImage();
     add(connectBtn = new LatchButton("Connect", img));
     connectBtn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/fileopen.gif"), "file open").getImage();
     add(btn = new LatchButton("Open", img));
     btn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/bolt.gif"), "drawer").getImage();
     add(drawBtn = new LatchButton("Drawing", img));
     drawBtn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/editor.gif"), "editor").getImage();
     add(editBtn = new LatchButton("Editor", img));
     editBtn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/help.gif"), "help").getImage();
     add(helpBtn = new LatchButton("Guide", img));
     helpBtn.addActionListener(svServer);


     img = svServer.loadImageIcon(getClass().getResource("icons/recyc.gif"), "kill all").getImage();
     add(btn = new LatchButton("Kill All", img));
     btn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/no.gif"), "check all").getImage();
     add(checkBtn = new LatchButton("Check All", img));
     img = svServer.loadImageIcon(getClass().getResource("icons/yes.gif"), "check all").getImage();
     checkBtn.addChangingImage(img);
     checkBtn.addActionListener(svServer);

     img = svServer.loadImageIcon(getClass().getResource("icons/exit.gif"), "exit").getImage();
     add(btn = new LatchButton("Exit", img));
     btn.addActionListener(svServer);

     validate();
  }


} // end of class

