package sv.drawer;

/** 
 * HotSpot.java
 * HotSpot object
 * @version 0.5     9/15/97
 * @author Byeongseob Ki
 */

import java.awt.*;
import java.util.*;

public class HotSpot extends Observable {
   private Point _point;
   private Dimension _dim;
   private boolean choosed = true;

   public HotSpot() {
      _point = new Point(0, 0);
      _dim = new Dimension(10, 10);
   }

   public HotSpot(Point coord) {
      _point = new Point(coord);
      _dim = new Dimension(10, 10);
   }

   public HotSpot(Point coord, Dimension dim) {
      _point = new Point(coord);
      _dim = new Dimension(dim);
   }

   public Point getPoint() {
      return new Point(_point);
   }

   public void setPoint(Point coord) {
      _point = new Point(coord);

      setChanged();
   }

   public Dimension getDimension() {
      return new Dimension(_dim);
   }

   public void setDimension(Dimension dim) {
      _dim = new Dimension(dim);

      setChanged();
   }

   public void setState(boolean b) {
      choosed = b;
   }

   public void paint(Graphics g) {
      if (choosed) 
         g.fillRect(_point.x - _dim.width / 2,  _point.y - _dim.height / 2,
                 _dim.width - 1, _dim.height - 1);
   }

   public boolean isAt(Point coord) {
      if ((coord.x >= _point.x - _dim.width / 2) &&
          (coord.x <= _point.x + (_dim.width - 1) / 2) &&
          (coord.y >= _point.y - _dim.height / 2) &&
          (coord.y <= _point.y + (_dim.height - 1) / 2)) {
         return true;
      }

      return false;
   }
}
