package sv.drawer;

/** 
 * HotSpotMgr.java
 * HotSpot manager
 * @version 0.5     9/15/97
 * @author Byeongseob Ki
 */

import java.awt.*;
import java.util.*;

public class HotSpotMgr {
   private Vector _vec;
   private int hspos;

   public HotSpotMgr() {
      _vec = new Vector();
   }

   public void manage(HotSpot hs) {
      _vec.addElement(hs);
   }

   public HotSpot isAt(Point coord) {
      hspos = -1;
      for (int i = 0; i < _vec.size(); i++) {
         HotSpot hs = (HotSpot)_vec.elementAt(i);
         
         if (hs.isAt(coord)) {
            hspos = i;
            return hs;
         }
      }
      return null;
   }

  public int HSPosition() {
    return hspos;
  }

  public HotSpot isAt(int index) {
     if (index < 0) return null;
     return (HotSpot)_vec.elementAt(index);
  }

   /**
    * remove hotspots
    */
   public void removeElements(Vector vec) {
     for (int i=0; i<vec.size(); i++) {
        HotSpot hs = (HotSpot)vec.elementAt(i);
        _vec.removeElement(hs);
     }
     vec.removeAllElements();
     vec = null;
   }
}




