package sv.drawer;

import java.awt.*;
import java.util.*;

/** 
 * ShapeObject.java
 * Define shape object
 * @version 1.0     10/15/97
 * @author Byeongseob Ki
 */

public abstract class ShapeObject implements Observer {
   protected int type = -1;
   protected boolean focused = false;
   protected boolean isRelativeDrawing = true;
   protected Color bgColor;

   /**
    * it is not really need but for a time being ...
    * USED TO DRAW ARRW
    */
   public void setBGColor(Color c) {
      bgColor = c;
   }

   /**
    * focus setting
    */
   public void setFocus(boolean b) {
      focused = b;
   }

   /**
    * return if object is focused
    */
   public boolean isFocused() {
      return focused;
   }

   /**
    * return object type
    */
   public int getType() {
      return type;
   }

   // if set true, relative drawing according to window size
   public void setRelativeDrawing(boolean b) {
      isRelativeDrawing = b;
   }

   protected Point getChangedValue(double xfactor, double yfactor, Point p) {
     return new Point((int)(xfactor*(double)p.x), (int)(yfactor*(double)p.y));
   }

   // window size is changed
   public abstract void changeCoordinates(double xfactor, double yfactor);

   public abstract String makeString();
   public abstract Vector getHotSpots();
   public abstract void paint(Graphics g);
   public abstract boolean contains(int x, int y);

}


