package sv.kernel;

import java.awt.*;

/** 
 * Configs.java
 * define abstact Configuration values
 * @version 1.0   10/1/97 
 * @author Byeongseob Ki
 */

public abstract class Configs {
   public boolean global_mode = true;
   public boolean overlay_mode = false;
   public boolean discard_mode = false;
   public boolean display_time = true;
   public Color bgColor = Color.white;

   public int bufferSize = Integer.MAX_VALUE;

   /**
    * return  setting values
    */
   public abstract String[] getSettings();

   /**
    * return setting values which is need for file writing
    */
   public abstract String getFileSettings();

   /**
    * set setting values from the arguments
    */
   public abstract void doConfig(String[] args);

}
