package sv.kernel;

import java.awt.*;
import java.util.*;

/**
 * This class holds contour information for one TimeData2D
 */

public class ContourData {
  int received = 0;
  
  float[] levelArr;
  Vector[] lineDataArr;

  /**
   * prepare contour data
   */
  public ContourData(int size) {
     levelArr = new float[size];
     lineDataArr = new Vector[size];
  }
  
  /**
   * add contour line
   */
  public synchronized void addContourLine(float level, Vector data) {
     levelArr[received] = level;
     lineDataArr[received] = data;
     received++;
  }

  /**
   * return level
   */
  public float getLevel(int i) {
    return levelArr[i];
  }

  /**
   * return contour data
   */
  public Vector getData(int i) {
     return lineDataArr[i];
  }

  /**
   * return total number of contour lines
   */
  public int getCount() {
    return received;
  }
}




