package sv.kernel;

import java.awt.*;
import java.io.*;
import java.util.*;

import sv.util.*;
import sv.ui.MarkerChooser;

/** 
 * DataSet1D.java
 * Define our scientific data
 * @version 1.0  10/15/97 
 * @author Byeongseob Ki
 */

public class DataSet1D extends DSPlane {

  private int markerType = MarkerChooser.CIRCLEMARKER;
  private Color lineColor = Color.red;


  /**
   * constructor to produce dataset
   * @param title title of this data set
   * @param timedataVec time data vector
   */
  public DataSet1D(String title, Vector timeDataVec) {
    super(title, timeDataVec);
    dataType = DSPlane.NORMAL;
  }


  /**
   * constructor from one TimeData1D
   * @param title title of this class
   * @param timedata TimeData1D to be added
   */
  public DataSet1D(String title, TimeData1D timedata) {
    super(title, timedata);
    dataType = DSPlane.NORMAL;
  }

 
   /**
    * set marker type
    */
   public void setMarkerType(int i) {
       markerType = i;
   }

   /**
    * set line color
    */
   public void setLineColor(Color c) {
       lineColor = c;
   }

   /**
    * return marker type
    */ 
   public int getMarkerType() {
       return markerType;
   }

   /**
    * set marker type
    */
   public Color getLineColor() {
       return lineColor;
   }

} // end of class
