package sv.kernel;

import java.io.*;

/** 
 * TimeData.java
 * Define point data in each time
 * @version 1.0     10/1/97
 * @author Byeongseob Ki
 */

public abstract class TimeData {

  /**
   * time value of this time data
   */
  protected float time;


  /**
   *  number of points in given time
   */
  protected int noOfPoints;


  /**
   * return time
   */
  public float getTime() {
     return time;
  }

  /**
   * return noOfPoints
   */
  public int getnoOfPoints() {
     return noOfPoints;
  }

  /**
   * sending data by using DataOutputStream
   * This method will be used in collaboration mode
   */
  public abstract void sendingData(DataOutputStream out);

} // end of class


