package sv.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


/** 
 * LabelInputDialog.java
 * To get the user input
 * @version 1.0
 * @author Byeongseob Ki
 */


public class LabelInputDialog extends Dialog implements ActionListener {
    // labels to be changed
    String labels[];

    TextField tfs[];

    public LabelInputDialog(Frame frame, String[] titles, String[] lbls) {
        super(frame, "Label Change", true);   // make it modal
        labels = lbls;
        tfs = new TextField[lbls.length];

        makeGUI(titles);
        pack();
    }

    public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();

        if (command.equals("Apply")) {
            for (int i = 0; i < tfs.length; i++)
                labels[i] = tfs[i].getText().trim();
            dispose();
        } else if (command.equals("Clear")) {
            for (int j = 0; j < tfs.length; j++)
                tfs[j].setText("");
            return;
        } else if (command.equals("Cancel")) {
            labels = null;
            dispose();
        }
    }

    public String[] getLabels() {
        return labels;
    }

    private void makeGUI(String[] titles) {
        int size = titles.length;

        setLayout(new BorderLayout());

        JPanel p = new JPanel();
        p.setLayout(new GridLayout(size, 2));
        p.setBorder(new TitledBorder("Change Labels"));

        for (int j=0; j<size; j++) {
            p.add(new Label(titles[j], 0));
            p.add(tfs[j] = new TextField(20));
            tfs[j].setText(labels[j]);
            tfs[j].setForeground(Color.blue);
        }

        // button panel
        Panel p2 = new Panel();
        p2.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));

        Button btn = new Button("Apply");
        btn.addActionListener(this);
        p2.add(btn);

        btn = new Button("Clear");
        btn.addActionListener(this);
        p2.add(btn);

        btn = new Button("Cancel");
        btn.addActionListener(this);
        p2.add(btn);

        add("Center", p);
        add("South", p2);
    }
}
