package sv.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;


/** 
 * ReplyDialog.java
 * To get the user input
 * @version 1.0
 * @author Byeongseob Ki
 */

public class ReplyDialog extends Dialog implements ActionListener {

  // hostname
  String hostname;

  // port
  int port;

  // check box
  Checkbox masterCheck;

  int masterMode = 1;
  boolean accepted = false;


  /** 
   * constructor
   * @param svserver parent class
   * @param title title of the panel
   * @param label label to display
   */
  public ReplyDialog(Frame fr, String hostname, int port, 
                                      String title, String label) {
     super(fr, "Collaboration Requested", true);

     this.hostname = hostname;
     this.port = port;

     // make GUI components
     makeGUI(title, label);
     pack();
  }


  /**
   * overrided method
   */
  public void actionPerformed(ActionEvent evt) {
     String command = evt.getActionCommand();

     int mode;
     if (masterCheck.getState()) 
         mode = 1;
     else
         mode = 0;

     if (command.equals("Accept"))    
        accepted = true;
     else if (command.equals("Refuse"))     
        accepted = false;

     dispose();
  }

  public int getConnectionMode() {
        return masterMode;
  }

  public boolean isAccepted() {
        return accepted;
  }


  // make GUI of this class
  private void makeGUI(String title, String label) {
     setLayout(new BorderLayout());

     JPanel p = new JPanel();
     p.setLayout(new BorderLayout());
     p.setBorder(new TitledBorder(title));

     Label lbl = new Label(label, Label.LEFT);
     p.add("Center", lbl);
     lbl.setForeground(Color.blue);
     p.add("South", masterCheck = new Checkbox("Allow Master Mode", true));

     Panel dummy = new Panel();      // for buttons
     dummy.setLayout(new FlowLayout(FlowLayout.RIGHT, 5, 5));
    
     Button okbtn = new Button("Accept");
     okbtn.addActionListener(this);
     dummy.add(okbtn);

     Button refusebtn = new Button("Refuse");
     refusebtn.addActionListener(this);
     dummy.add(refusebtn);

     add("Center", p);
     add("South", dummy);
  }
}

