package sv.ui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import com.sun.java.swing.*;
import com.sun.java.swing.border.*;
import com.sun.java.swing.event.*;


/** 
 * SlideInputDialog.java
 * To get the user input
 * @version 1.0
 * @author Byeongseob Ki
 */


public class SlideInputDialog extends Dialog implements ActionListener {
    private JSlider slider;
    private Label slideValue;

    // choosed value by slider
    int choosed;

    public SlideInputDialog(Frame frame, 
       String title, String lbl1, String lbl2, int min, int max, int val) {

        super(frame, title, true);   // make it modal
        makeGUI(title, lbl1, lbl2, min, max, val);

        choosed = val;
        pack();
    }

    public void actionPerformed(ActionEvent e) {
        String command = e.getActionCommand();

        if (command.equals("Done"))
            dispose();
    }

    public int getChoosedValue() {
        return choosed;
    }

    public Dimension getPreferredSize() {
        return new Dimension(320, 150);
    }

    private void makeGUI(String title, String lbl1, String lbl2, 
                             int min, int max, int val) {
        setLayout(new BorderLayout());

        JPanel p = new JPanel();
        p.setLayout(new BorderLayout());
        p.setBorder(new TitledBorder(title));

        Panel p1 = new Panel();
        p1.setLayout(new GridLayout(2, 1));
        p1.add(new Label(lbl1, 0));
        p1.add(new Label(lbl2, 0));
        p.add("North", p1);

        Panel p2 = new Panel();
        p2.setLayout(new BorderLayout());
        p2.add("Center", slider = 
                       new JSlider(JSlider.HORIZONTAL, min, max, val));
        p2.add("East", slideValue = new Label(String.valueOf(choosed)));
        p.add("Center", p2);
        createSlideListener();

        Panel btnp = new Panel();
        btnp.setLayout(new FlowLayout(FlowLayout.RIGHT));

        Button button = new Button("Done");
        button.addActionListener(this);
        btnp.add(button);
        add("Center", p);
        add("South", btnp);
    }

  // slide value changes
  void createSlideListener() {
     ChangeListener changeListener = new ChangeListener() {
        public void stateChanged(ChangeEvent e) {
           slideValue.setText(String.valueOf(slider.getValue()));
        }
     };
     slider.addChangeListener(changeListener);
  }
 
}

